SystemOrganization addCategory: #ConfigurationOfWorkingSet!

Object subclass: #ConfigurationOfWorkingSet
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfWorkingSet'!

!ConfigurationOfWorkingSet class methodsFor: 'development support' stamp: 'AlexandreBergel 12/17/2014 15:31'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfWorkingSet class methodsFor: 'private' stamp: 'AlexandreBergel 12/17/2014 15:31'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfWorkingSet class methodsFor: 'private' stamp: 'AlexandreBergel 12/17/2014 15:31'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfWorkingSet class methodsFor: 'private' stamp: 'AlexandreBergel 12/17/2014 15:31'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfWorkingSet class methodsFor: 'metacello tool support' stamp: 'AlexandreBergel 12/17/2014 15:31'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfWorkingSet class methodsFor: 'loading' stamp: 'AlexandreBergel 12/17/2014 15:31'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfWorkingSet class methodsFor: 'loading' stamp: 'AlexandreBergel 12/17/2014 15:31'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfWorkingSet class methodsFor: 'loading' stamp: 'AlexandreBergel 12/17/2014 15:31'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfWorkingSet class methodsFor: 'accessing' stamp: 'AlexandreBergel 12/17/2014 15:31'!
project

	^self new project! !

!ConfigurationOfWorkingSet class methodsFor: 'development support' stamp: 'AlexandreBergel 12/17/2014 15:31'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfWorkingSet methodsFor: 'baselines' stamp: 'AlexandreBergel 12/17/2014 15:33'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec package: 'WorkingSet'.
		spec blessing: #'baseline'. ].
! !

!ConfigurationOfWorkingSet methodsFor: 'accessing' stamp: 'AlexandreBergel 12/17/2014 15:31'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfWorkingSet methodsFor: 'symbolic versions' stamp: 'AlexandreBergel 12/17/2014 15:31'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1-baseline'.
! !

!ConfigurationOfWorkingSet methodsFor: 'accessing' stamp: 'AlexandreBergel 12/17/2014 15:31'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfWorkingSet methodsFor: 'symbolic versions' stamp: 'AlexandreBergel 12/17/2014 15:36'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '0.1-baseline'.
! !
